/*  Выполнение действий, список возможных акций Beast

*/

package TerminalActions

import (
	"BOT/brain/action_sensor"
	"BOT/brain/gomeostas"
	"BOT/lib"
	"strconv"
	"strings"
)

////////////////////////////////////////////////////////////////////
func init(){
	loadTerminalActons()
}


////////////////////////////////////////////////////////////////

var EnergyDescrib = []string{
	"Едва (сила=1)",
	"Очень слабо (сила=2)",
	"Слабо (сила=3)",
	"Ощутимо (сила=4)",
	"Средне (сила=5)",
	"Повышенно (сила=6)",
	"Настойчиво (сила=7)",
	"Сильно (сила=8)",
	"Очень сильно (сила=9)",
	"Максимально (сила=10)",
}
///////////////////////////////////

/* Генетические цели действий Beast ID гомео-параметров, которые призвано улучшить данное действие - по его ID
Значение 10 означает - для всех параметров - улучшение.

Это – наследственно заданная цель действия, не осознаваемая при его совершении.
Но с опытом каждому действию в конкретных условиях (и к ним добавляются слова и фразы)
будет ассоциироваться смысл (осознаваемая значимость).
 */
var TerminalActionsTargetsFromID=make(map[int][]int)
//////////////////////////////////


// ПУЛЬС
var ReflexPulsCount=0 // передача тика Пульса из brine.go
var LifeTime=0
var EvolushnStage=0  // стадия развития
var IsSlipping=false
// коррекция текущего состояния гомеостаза и базового контекста с каждым пульсом
func TermineteActionCountPuls(evolushnStage int,lifeTime int,puls int,isSlipping bool) {
	LifeTime = lifeTime
	EvolushnStage = evolushnStage
	ReflexPulsCount = puls // передача номера тика из более низкоуровневого пакета
	IsSlipping = isSlipping

	pulsSimpleReflexex()
}


/* затратные последствия ответного действия
т.е. то, как изменятся параметры гомеостаза при совершении данного действия
*/
type TerminalActionsExpenses struct {
	GomeoID int // ID затрагиваемого параметра гоместаза
	Diff float64 // на сколько изменится параметр
}

// имя ответного действия по его ID
var TerminalActonsNameFromID=make(map[int]string)
// затратные последствия ответного действия по его ID
var TerminalActionsExpensesFromID=make(map[int][]TerminalActionsExpenses)
func loadTerminalActons(){
	TerminalActonsNameFromID=make(map[int]string)
	lines,_:=lib.ReadLines(lib.GetMainPathExeFile()+"/memory_reflex/terminal_actons.txt")
	for i := 0; i < len(lines); i++ {
		p := strings.Split(lines[i], "|")
		id, _ := strconv.Atoi(p[0])
		TerminalActonsNameFromID[id]=p[1]
		//это действия приводит к изменению гомео-параметров:
		var expenses []TerminalActionsExpenses
		se := strings.Split(p[2], ";")
		for j := 0; j < len(se); j++ {
			if len(se[j])==0{
				continue
			}
			e := strings.Split(se[j], ">")
			e1,_:=strconv.Atoi(e[0])
			e2,_:=strconv.ParseFloat(e[1], 64);
			expenses=append(expenses,TerminalActionsExpenses{e1,e2})
		}
		TerminalActionsExpensesFromID[id]=expenses

		tg := strings.Split(p[3], ",")

		var tgArr []int
		for j := 0; j < len(tg); j++ {
			if len(tg[j])==0{continue}
			gID,_:=strconv.Atoi(tg[j])
			tgArr=append(tgArr,gID)
		}
		TerminalActionsTargetsFromID[id]=tgArr
	}
	return
}
////////////////////////////////////////////


////////////  Beast кормится из выданной порции
// один акт кормления пополняет энергию на 30%
func BotEatingFood()(int){
	var portion=30
	res:=CheckEnoughFood(portion)

	if res==2{// больше не хочет есть
		return 2
	}

	if res==1{//еды больше порции
		// сколько Beast уже съел и нужно превратить в энергию (сразу писать нельзя из-за паники: "concurrent map read and map write")
		gomeostas.FoodPortionEaten+=action_sensor.FoodPortionForEnergi // еда - в энергию
		action_sensor.FoodPortionForEnergi-=portion
		if action_sensor.FoodPortionForEnergi<0{
			action_sensor.FoodPortionForEnergi=0
		}
		return 1
	}
	if res==0{// еды меньше порции
			gomeostas.FoodPortionEaten+=action_sensor.FoodPortionForEnergi // вся еда - в энергию
			action_sensor.FoodPortionForEnergi=0
			return 0
		}

	return 0
}
/////////////////////////////////////////////

/* есть ли достаточно еды для кормления:
0- еды меньше порции
1- еды больше порции
2- больше не хочет есть
 */
func CheckEnoughFood(portion int)(int){
	// сколько сможет съесть? сколько отсалось до 100
	energi:=gomeostas.GomeostazParams[1]
	can:=100-gomeostas.GomeostazParams[1]
	if energi>95{// больше не хочет есть
		return 2
	}
	if can<30{
		portion=int(30-can)
	}
	if action_sensor.FoodPortionForEnergi>=portion{// еды больше порции
		return 1
	}else{// еды меньше порции
		if energi<10 && action_sensor.FoodPortionForEnergi<10{
			gomeostas.FoodPortionEaten+=action_sensor.FoodPortionForEnergi // еда - в энергию
			action_sensor.FoodPortionForEnergi=0
			return 0
		}
		if action_sensor.FoodPortionForEnergi < portion{
			portion=action_sensor.FoodPortionForEnergi
		}
		return 1
	}
	return 0
}
///////////////////////////////////////////////////////

// termineteAction.CorrectActionForFood(actionID)
func CorrectActionForFood(actionID int)(int){
	// если Beast пытается поесть
	if actionID==5{
		res:=CheckEnoughFood(30)
		if res==0{// если нет еды
			actionID=77 //нет еды! Накорми!
		}
		if res==2{// уже насен и не может есть
			actionID=78 // не хочу больше есть
		}
	}
	return actionID
}
//////////////////////////////////////////////////











/// уже выполнявшиеся при бодствовании простейшие рефлексы
var usedSimpleReflexexsID []int
func pulsSimpleReflexex(){
	if IsSlipping && len(usedSimpleReflexexsID)>0 {
		usedSimpleReflexexsID=nil
	}
}

/* выбрать подходящий простейший рефлекс и вернуть его действие
TerminalActions.ChooseSimpleReflexexAction
*/
func ChooseSimpleReflexexAction()(bool,int,[]int){
	// выявить ID парамктров гомеостаза как цели для улучшения в данных условиях
	veryActual,targetID:=gomeostas.FindTargetGomeostazID()
	// подходящие действия
	var aArr []int
	// выбранные
	var fActsID []int
	// одно из выбранных
	var singleActID=0
	// выдать массив возможных действий чтобы выбрать одно из них, пока еще не испытанное
	for _, gIDarr := range TerminalActionsTargetsFromID {
		// выбрать подхлдящие ID параметров гомеостаза для данной цели
		aArr=lib.GetExistsIntArs(targetID,gIDarr)
		if aArr==nil{
			continue
		}
		for i := 0; i < len(aArr); i++ {
			// исключить те, что уже использовались
			if lib.ExistsValInArr(usedSimpleReflexexsID,aArr[i]){
				continue
			}
			fActsID = append(fActsID, aArr[i])
		}
	}
	if len(fActsID)==0{
		if len(aArr)==0{
			return false,0,nil
		}
		// снова обнулить usedSimpleReflexexsID
		singleActID=aArr[0]
		usedSimpleReflexexsID=nil
	}else{
		singleActID=fActsID[0]
	}
	// корректировка для Действия "Кормится"
	singleActID=CorrectActionForFood(singleActID)

	usedSimpleReflexexsID=append(usedSimpleReflexexsID,singleActID)

	return veryActual,singleActID,targetID
}
//////////////////////////////////////




